local Attributes =  FlexBar2:NewModule("Attributes");
local SecureStateDriverFrame = CreateFrame("Frame", nil, UIParent, "SecureStateDriverTemplate");


Attributes.ButtonMixin = FlexBar2.OO.Mixin
{
	"GetAttribute",
	"GetModifiedAttribute",
    "SetAttribute",
    "SetModifiedAttribute",
};

function Attributes.ButtonMixin:Initialize()
    self.AttributeCache = {};
    SecureStateDriverFrame:SetAttribute("addchild", self.Frame);
end

function Attributes.ButtonMixin:SetDefaults()
    self.InfoTable.Attributes = {};
end

function Attributes.ButtonMixin:LoadSettings()
    for Attribute, Value in pairs(self.InfoTable.Attributes) do
        self:SetAttribute(Attribute, Value);
    end
end

function Attributes.ButtonMixin:GetAttribute(Attribute)
	return self.Frame:GetAttribute(Attribute);
end

function Attributes.ButtonMixin:GetModifiedAttribute(Attribute)
	return self:GetAttribute(SecureButton_GetModifierPrefix() .. Attribute .. SecureButton_GetButtonSuffix(SecureStateChild_GetEffectiveButton(self.Frame))) or 
	self:GetAttribute("*" .. Attribute .. SecureButton_GetButtonSuffix(SecureStateChild_GetEffectiveButton(self.Frame)));
end

function Attributes.ButtonMixin:SetAttribute(Attribute, Value)
    self.Frame:SetAttribute(Attribute, Value);
    self.InfoTable.Attributes[Attribute] = Value;
    FlexBar2:Debug("Setting Attribute [", Attribute, "] to ", self.InfoTable.Attributes[Attribute]);
end

function Attributes.ButtonMixin:SetModifiedAttribute(Attribute, Value)
	local Prefix = SecureButton_GetModifierPrefix();
	if(Prefix == "") then Prefix = "*"; end
	self:SetAttribute(Prefix .. Attribute .. SecureButton_GetButtonSuffix(SecureStateChild_GetEffectiveButton(self.Frame)), Value); 
end
